package mx.resources
{
   import flash.system.ApplicationDomain;
   import mx.core.mx_internal;
   import mx.utils.StringUtil;
   
   use namespace mx_internal;
   
   public class ResourceBundle
   {
      mx_internal static const VERSION:String = "2.0.1.0";
      
      private var content:Object;
      
      private var bundleName:String;
      
      public function ResourceBundle()
      {
         super();
      }
      
      private static function getDefinitionByName(param1:String, param2:ApplicationDomain) : Object
      {
         var _loc3_:Object = null;
         if(param2.hasDefinition(param1))
         {
            _loc3_ = param2.getDefinition(param1);
         }
         return _loc3_;
      }
      
      public static function getResourceBundle(param1:String, param2:ApplicationDomain = null) : ResourceBundle
      {
         var _loc3_:Class = null;
         var _loc4_:Object = null;
         var _loc5_:ResourceBundle = null;
         if(param2 == null)
         {
            param2 = ApplicationDomain.currentDomain;
         }
         _loc3_ = Class(getDefinitionByName(param1 + "_properties",param2));
         if(!_loc3_)
         {
            _loc3_ = Class(getDefinitionByName(String(param1),param2));
         }
         if(_loc3_)
         {
            _loc4_ = new _loc3_();
            if(_loc4_ is ResourceBundle)
            {
               _loc5_ = ResourceBundle(_loc4_);
               _loc5_.initialize(String(param1));
               return _loc5_;
            }
         }
         throw new Error("Could not find resource bundle " + param1);
      }
      
      protected function getContent() : Object
      {
         return null;
      }
      
      public function getStringArray(param1:String) : Array
      {
         var _loc2_:Array = null;
         var _loc3_:int = 0;
         var _loc4_:int = 0;
         _loc2_ = getObject(param1).split(",");
         _loc3_ = int(_loc2_.length);
         _loc4_ = 0;
         while(_loc4_ < _loc3_)
         {
            _loc2_[_loc4_] = StringUtil.trim(_loc2_[_loc4_]);
            _loc4_++;
         }
         return _loc2_;
      }
      
      public function getString(param1:String) : String
      {
         return String(getObject(param1));
      }
      
      private function initialize(param1:String) : void
      {
         bundleName = param1;
         content = getContent();
         if(!content)
         {
            throw new Error("No content found in resource bundle " + bundleName);
         }
      }
      
      public function getObject(param1:String) : Object
      {
         var _loc2_:Object = null;
         _loc2_ = content[param1];
         if(!_loc2_)
         {
            throw new Error("Key " + param1 + " was not found in resource bundle " + bundleName);
         }
         return _loc2_;
      }
      
      public function getBoolean(param1:String, param2:Boolean = true) : Boolean
      {
         var _loc3_:String = null;
         _loc3_ = getObject(param1).toLowerCase();
         if(_loc3_ == "false")
         {
            return false;
         }
         if(_loc3_ == "true")
         {
            return true;
         }
         return param2;
      }
      
      public function getNumber(param1:String) : Number
      {
         return Number(getObject(param1));
      }
   }
}

