package mx.skins.halo
{
   import flash.display.GradientType;
   import flash.display.Graphics;
   import mx.core.Container;
   import mx.core.EdgeMetrics;
   import mx.core.IUIComponent;
   import mx.core.mx_internal;
   import mx.graphics.RectangularDropShadow;
   import mx.skins.RectangularBorder;
   import mx.styles.IStyleClient;
   import mx.utils.ColorUtil;
   
   use namespace mx_internal;
   
   public class HaloBorder extends RectangularBorder
   {
      mx_internal static const VERSION:String = "2.0.1.0";
      
      private static var BORDER_WIDTHS:Object = {
         "none":0,
         "solid":1,
         "inset":2,
         "outset":2,
         "alert":3,
         "dropdown":2,
         "menuBorder":1,
         "comboNonEdit":2
      };
      
      private var _borderMetrics:EdgeMetrics;
      
      private var dropShadow:RectangularDropShadow;
      
      public function HaloBorder()
      {
         super();
         BORDER_WIDTHS["default"] = 3;
      }
      
      override public function get borderMetrics() : EdgeMetrics
      {
         var _loc1_:Number = NaN;
         var _loc2_:String = null;
         var _loc3_:String = null;
         if(_borderMetrics)
         {
            return _borderMetrics;
         }
         _loc2_ = getStyle("borderStyle");
         if(_loc2_ == "default" || _loc2_ == "alert")
         {
            _borderMetrics = new EdgeMetrics(0,0,0,0);
         }
         else if(_loc2_ == "controlBar" || _loc2_ == "applicationControlBar")
         {
            _borderMetrics = new EdgeMetrics(1,1,1,1);
         }
         else if(_loc2_ == "solid")
         {
            _loc1_ = getStyle("borderThickness");
            if(isNaN(_loc1_))
            {
               _loc1_ = 0;
            }
            _borderMetrics = new EdgeMetrics(_loc1_,_loc1_,_loc1_,_loc1_);
            _loc3_ = getStyle("borderSides");
            if(_loc3_ != "left top right bottom")
            {
               if(_loc3_.indexOf("left") == -1)
               {
                  _borderMetrics.left = 0;
               }
               if(_loc3_.indexOf("top") == -1)
               {
                  _borderMetrics.top = 0;
               }
               if(_loc3_.indexOf("right") == -1)
               {
                  _borderMetrics.right = 0;
               }
               if(_loc3_.indexOf("bottom") == -1)
               {
                  _borderMetrics.bottom = 0;
               }
            }
         }
         else
         {
            _loc1_ = Number(BORDER_WIDTHS[_loc2_]);
            if(isNaN(_loc1_))
            {
               _loc1_ = 0;
            }
            _borderMetrics = new EdgeMetrics(_loc1_,_loc1_,_loc1_,_loc1_);
         }
         return _borderMetrics;
      }
      
      private function drawDropShadow(param1:Number, param2:Number, param3:Number, param4:Number, param5:Number, param6:Number, param7:Number, param8:Number) : void
      {
         var _loc9_:Number = NaN;
         var _loc10_:String = null;
         var _loc11_:Number = NaN;
         var _loc12_:Boolean = false;
         if(getStyle("dropShadowEnabled") == false || getStyle("dropShadowEnabled") == "false" || param3 == 0 || param4 == 0)
         {
            return;
         }
         _loc9_ = getStyle("shadowDistance");
         _loc10_ = getStyle("shadowDirection");
         if(getStyle("borderStyle") == "applicationControlBar")
         {
            _loc12_ = getStyle("docked");
            _loc11_ = _loc12_ ? 90 : getDropShadowAngle(_loc9_,_loc10_);
            _loc9_ = Math.abs(_loc9_);
         }
         else
         {
            _loc11_ = getDropShadowAngle(_loc9_,_loc10_);
            _loc9_ = Math.abs(_loc9_) + 2;
         }
         if(!dropShadow)
         {
            dropShadow = new RectangularDropShadow();
         }
         dropShadow.distance = _loc9_;
         dropShadow.angle = _loc11_;
         dropShadow.color = getStyle("dropShadowColor");
         dropShadow.alpha = 0.4;
         dropShadow.tlRadius = param5;
         dropShadow.trRadius = param6;
         dropShadow.blRadius = param8;
         dropShadow.brRadius = param7;
         dropShadow.drawShadow(graphics,param1,param2,param3,param4);
      }
      
      private function draw3dBorder(param1:Number, param2:Number, param3:Number, param4:Number, param5:Number, param6:Number) : void
      {
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Graphics = null;
         _loc7_ = width;
         _loc8_ = height;
         drawDropShadow(0,0,width,height,0,0,0,0);
         _loc9_ = graphics;
         _loc9_.beginFill(param1);
         _loc9_.drawRect(0,0,_loc7_,_loc8_);
         _loc9_.drawRect(1,0,_loc7_ - 2,_loc8_);
         _loc9_.endFill();
         _loc9_.beginFill(param2);
         _loc9_.drawRect(1,0,_loc7_ - 2,1);
         _loc9_.endFill();
         _loc9_.beginFill(param3);
         _loc9_.drawRect(1,_loc8_ - 1,_loc7_ - 2,1);
         _loc9_.endFill();
         _loc9_.beginFill(param4);
         _loc9_.drawRect(1,1,_loc7_ - 2,1);
         _loc9_.endFill();
         _loc9_.beginFill(param5);
         _loc9_.drawRect(1,_loc8_ - 2,_loc7_ - 2,1);
         _loc9_.endFill();
         _loc9_.beginFill(param6);
         _loc9_.drawRect(1,2,_loc7_ - 2,_loc8_ - 4);
         _loc9_.drawRect(2,2,_loc7_ - 4,_loc8_ - 4);
         _loc9_.endFill();
      }
      
      private function getBackgroundColor() : Object
      {
         var _loc1_:IUIComponent = null;
         var _loc2_:Object = null;
         _loc1_ = parent as IUIComponent;
         if(Boolean(_loc1_) && !_loc1_.enabled)
         {
            _loc2_ = getStyle("backgroundDisabledColor");
            if(_loc2_)
            {
               return _loc2_;
            }
         }
         return getStyle("backgroundColor");
      }
      
      override public function styleChanged(param1:String) : void
      {
         if(param1 == null || param1 == "styleName" || param1 == "borderStyle" || param1 == "borderThickness" || param1 == "borderSides")
         {
            _borderMetrics = null;
         }
         invalidateDisplayList();
      }
      
      private function getDropShadowAngle(param1:Number, param2:String) : Number
      {
         if(param2 == "left")
         {
            return param1 >= 0 ? 135 : 225;
         }
         if(param2 == "right")
         {
            return param1 >= 0 ? 45 : 315;
         }
         return param1 >= 0 ? 90 : 270;
      }
      
      override protected function updateDisplayList(param1:Number, param2:Number) : void
      {
         var _loc3_:String = null;
         var _loc4_:Object = null;
         var _loc5_:Array = null;
         var _loc6_:Number = NaN;
         var _loc7_:String = null;
         var _loc8_:Object = null;
         var _loc9_:uint = 0;
         var _loc10_:uint = 0;
         var _loc11_:String = null;
         var _loc12_:Number = NaN;
         var _loc13_:uint = 0;
         var _loc14_:Boolean = false;
         var _loc15_:uint = 0;
         var _loc16_:Array = null;
         var _loc17_:Array = null;
         var _loc18_:uint = 0;
         var _loc19_:uint = 0;
         var _loc20_:uint = 0;
         var _loc21_:uint = 0;
         var _loc22_:Boolean = false;
         var _loc23_:Number = NaN;
         var _loc24_:Object = null;
         var _loc25_:* = false;
         var _loc26_:Object = null;
         var _loc27_:Number = NaN;
         var _loc28_:Number = NaN;
         var _loc29_:Number = NaN;
         var _loc30_:Object = null;
         var _loc31_:Graphics = null;
         var _loc32_:Number = NaN;
         var _loc33_:Number = NaN;
         var _loc34_:Container = null;
         var _loc35_:EdgeMetrics = null;
         var _loc36_:* = false;
         var _loc37_:Number = NaN;
         var _loc38_:Array = null;
         var _loc39_:uint = 0;
         var _loc40_:Boolean = false;
         var _loc41_:Number = NaN;
         var _loc42_:Number = NaN;
         var _loc43_:Number = NaN;
         var _loc44_:EdgeMetrics = null;
         var _loc45_:Number = NaN;
         var _loc46_:Number = NaN;
         if(isNaN(param1) || isNaN(param2))
         {
            return;
         }
         super.updateDisplayList(param1,param2);
         _loc3_ = getStyle("borderStyle");
         _loc4_ = getBackgroundColor();
         _loc5_ = getStyle("highlightAlphas");
         _loc7_ = "backgroundAlpha";
         _loc23_ = 0;
         _loc24_ = null;
         _loc25_ = false;
         _loc31_ = graphics;
         _loc31_.clear();
         if(_loc3_)
         {
            switch(_loc3_)
            {
               case "none":
                  break;
               case "inset":
                  _loc10_ = getStyle("borderColor");
                  _loc27_ = ColorUtil.adjustBrightness2(_loc10_,-40);
                  _loc28_ = ColorUtil.adjustBrightness2(_loc10_,25);
                  _loc29_ = ColorUtil.adjustBrightness2(_loc10_,40);
                  _loc30_ = _loc4_;
                  if(_loc30_ === null || _loc30_ === "")
                  {
                     _loc30_ = _loc10_;
                  }
                  draw3dBorder(_loc28_,_loc27_,_loc29_,Number(_loc30_),Number(_loc30_),Number(_loc30_));
                  break;
               case "outset":
                  _loc10_ = getStyle("borderColor");
                  _loc27_ = ColorUtil.adjustBrightness2(_loc10_,-40);
                  _loc28_ = ColorUtil.adjustBrightness2(_loc10_,-25);
                  _loc29_ = ColorUtil.adjustBrightness2(_loc10_,40);
                  _loc30_ = _loc4_;
                  if(_loc30_ === null || _loc30_ === "")
                  {
                     _loc30_ = _loc10_;
                  }
                  draw3dBorder(_loc28_,_loc29_,_loc27_,Number(_loc30_),Number(_loc30_),Number(_loc30_));
                  break;
               case "alert":
               case "default":
                  _loc32_ = getStyle("backgroundAlpha");
                  _loc6_ = getStyle("borderAlpha");
                  _loc7_ = "borderAlpha";
                  _loc23_ = getStyle("cornerRadius");
                  _loc25_ = getStyle("roundedBottomCorners").toString().toLowerCase() == "true";
                  _loc33_ = _loc25_ ? _loc23_ : 0;
                  drawDropShadow(0,0,param1,param2,_loc23_,_loc23_,_loc33_,_loc33_);
                  if(!_loc25_)
                  {
                     _loc24_ = {};
                  }
                  _loc34_ = parent as Container;
                  if(_loc34_)
                  {
                     _loc35_ = _loc34_.viewMetrics;
                     _loc8_ = {
                        "x":_loc35_.left,
                        "y":_loc35_.top,
                        "w":Math.max(0,param1 - _loc35_.left - _loc35_.right),
                        "h":Math.max(0,param2 - _loc35_.top - _loc35_.bottom),
                        "r":0
                     };
                     if(_loc8_.w > 0 && _loc8_.h > 0)
                     {
                        if(_loc32_ != _loc6_)
                        {
                           drawDropShadow(_loc8_.x,_loc8_.y,_loc8_.w,_loc8_.h,0,0,0,0);
                        }
                        _loc31_.beginFill(Number(_loc4_),_loc32_);
                        _loc31_.drawRect(_loc8_.x,_loc8_.y,_loc8_.w,_loc8_.h);
                        _loc31_.endFill();
                     }
                  }
                  _loc4_ = getStyle("borderColor");
                  break;
               case "dropdown":
                  _loc15_ = getStyle("dropdownBorderColor");
                  drawDropShadow(0,0,param1,param2,4,0,0,4);
                  drawRoundRect(0,0,param1,param2,{
                     "tl":4,
                     "tr":0,
                     "br":0,
                     "bl":4
                  },5068126,1);
                  drawRoundRect(0,0,param1,param2,{
                     "tl":4,
                     "tr":0,
                     "br":0,
                     "bl":4
                  },[16777215,16777215],[0.7,0],verticalGradientMatrix(0,0,param1,param2));
                  drawRoundRect(1,1,param1 - 1,param2 - 2,{
                     "tl":3,
                     "tr":0,
                     "br":0,
                     "bl":3
                  },16777215,1);
                  drawRoundRect(1,2,param1 - 1,param2 - 3,{
                     "tl":3,
                     "tr":0,
                     "br":0,
                     "bl":3
                  },[15658734,16777215],1,verticalGradientMatrix(0,0,param1 - 1,param2 - 3));
                  if(!isNaN(_loc15_))
                  {
                     drawRoundRect(0,0,param1 + 1,param2,{
                        "tl":4,
                        "tr":0,
                        "br":0,
                        "bl":4
                     },_loc15_,0.5);
                     drawRoundRect(1,1,param1 - 1,param2 - 2,{
                        "tl":3,
                        "tr":0,
                        "br":0,
                        "bl":3
                     },16777215,1);
                     drawRoundRect(1,2,param1 - 1,param2 - 3,{
                        "tl":3,
                        "tr":0,
                        "br":0,
                        "bl":3
                     },[15658734,16777215],1,verticalGradientMatrix(0,0,param1 - 1,param2 - 3));
                  }
                  _loc4_ = null;
                  break;
               case "menuBorder":
                  _loc10_ = getStyle("borderColor");
                  drawRoundRect(0,0,param1,param2,0,_loc10_,1);
                  drawDropShadow(1,1,param1 - 2,param2 - 2,0,0,0,0);
                  break;
               case "comboNonEdit":
                  break;
               case "controlBar":
                  if(param1 == 0 || param2 == 0)
                  {
                     _loc4_ = null;
                     break;
                  }
                  _loc17_ = getStyle("footerColors");
                  _loc36_ = _loc17_ != null;
                  _loc37_ = getStyle("borderAlpha");
                  if(_loc36_)
                  {
                     _loc31_.lineStyle(0,_loc17_.length > 0 ? uint(_loc17_[1]) : uint(_loc17_[0]),_loc37_);
                     _loc31_.moveTo(0,0);
                     _loc31_.lineTo(param1,0);
                     _loc31_.lineStyle(0,0,0);
                     if(Boolean(parent) && Boolean(parent.parent) && parent.parent is IStyleClient)
                     {
                        _loc23_ = IStyleClient(parent.parent).getStyle("cornerRadius");
                        _loc37_ = IStyleClient(parent.parent).getStyle("borderAlpha");
                     }
                     if(isNaN(_loc23_))
                     {
                        _loc23_ = 0;
                     }
                     if(IStyleClient(parent.parent).getStyle("roundedBottomCorners").toString().toLowerCase() != "true")
                     {
                        _loc23_ = 0;
                     }
                     drawRoundRect(0,1,param1,param2 - 1,{
                        "tl":0,
                        "tr":0,
                        "bl":_loc23_,
                        "br":_loc23_
                     },_loc17_,_loc37_,verticalGradientMatrix(0,0,param1,param2));
                     if(_loc17_.length > 1 && _loc17_[0] != _loc17_[1])
                     {
                        drawRoundRect(0,1,param1,param2 - 1,{
                           "tl":0,
                           "tr":0,
                           "bl":_loc23_,
                           "br":_loc23_
                        },[16777215,16777215],_loc5_,verticalGradientMatrix(0,0,param1,param2));
                        drawRoundRect(1,2,param1 - 2,param2 - 3,{
                           "tl":0,
                           "tr":0,
                           "bl":_loc23_ - 1,
                           "br":_loc23_ - 1
                        },_loc17_,_loc37_,verticalGradientMatrix(0,0,param1,param2));
                     }
                  }
                  _loc4_ = null;
                  break;
               case "applicationControlBar":
                  _loc16_ = getStyle("fillColors");
                  _loc6_ = getStyle("backgroundAlpha");
                  _loc5_ = getStyle("highlightAlphas");
                  _loc38_ = getStyle("fillAlphas");
                  _loc14_ = getStyle("docked");
                  _loc39_ = uint(_loc4_);
                  _loc23_ = getStyle("cornerRadius");
                  if(!_loc23_)
                  {
                     _loc23_ = 0;
                  }
                  drawDropShadow(0,1,param1,param2 - 1,_loc23_,_loc23_,_loc23_,_loc23_);
                  if(_loc4_)
                  {
                     drawRoundRect(0,1,param1,param2 - 1,_loc23_,_loc39_,_loc6_,verticalGradientMatrix(0,0,param1,param2));
                  }
                  drawRoundRect(0,1,param1,param2 - 1,_loc23_,_loc16_,_loc38_,verticalGradientMatrix(0,0,param1,param2));
                  drawRoundRect(0,1,param1,param2 / 2 - 1,{
                     "tl":_loc23_,
                     "tr":_loc23_,
                     "bl":0,
                     "br":0
                  },[16777215,16777215],_loc5_,verticalGradientMatrix(0,0,param1,param2 / 2 - 1));
                  drawRoundRect(0,1,param1,param2 - 1,{
                     "tl":_loc23_,
                     "tr":_loc23_,
                     "bl":0,
                     "br":0
                  },16777215,0.3,null,GradientType.LINEAR,null,{
                     "x":0,
                     "y":2,
                     "w":param1,
                     "h":param2 - 2,
                     "r":{
                        "tl":_loc23_,
                        "tr":_loc23_,
                        "bl":0,
                        "br":0
                     }
                  });
                  _loc4_ = null;
                  break;
               default:
                  _loc10_ = getStyle("borderColor");
                  _loc12_ = getStyle("borderThickness");
                  _loc11_ = getStyle("borderSides");
                  _loc40_ = true;
                  _loc23_ = getStyle("cornerRadius");
                  _loc25_ = getStyle("roundedBottomCorners").toString().toLowerCase() == "true";
                  _loc41_ = Math.max(_loc23_ - _loc12_,0);
                  _loc26_ = {
                     "x":_loc12_,
                     "y":_loc12_,
                     "w":param1 - _loc12_ * 2,
                     "h":param2 - _loc12_ * 2,
                     "r":_loc41_
                  };
                  if(!_loc25_)
                  {
                     _loc24_ = {
                        "tl":_loc23_,
                        "tr":_loc23_,
                        "bl":0,
                        "br":0
                     };
                     _loc26_.r = {
                        "tl":_loc41_,
                        "tr":_loc41_,
                        "bl":0,
                        "br":0
                     };
                  }
                  if(_loc11_ != "left top right bottom")
                  {
                     _loc26_.r = {
                        "tl":_loc41_,
                        "tr":_loc41_,
                        "bl":(_loc25_ ? _loc41_ : 0),
                        "br":(_loc25_ ? _loc41_ : 0)
                     };
                     _loc24_ = {
                        "tl":_loc23_,
                        "tr":_loc23_,
                        "bl":(_loc25_ ? _loc23_ : 0),
                        "br":(_loc25_ ? _loc23_ : 0)
                     };
                     _loc11_ = _loc11_.toLowerCase();
                     if(_loc11_.indexOf("left") == -1)
                     {
                        _loc26_.x = 0;
                        _loc26_.w += _loc12_;
                        _loc26_.r.tl = 0;
                        _loc26_.r.bl = 0;
                        _loc24_.tl = 0;
                        _loc24_.bl = 0;
                        _loc40_ = false;
                     }
                     if(_loc11_.indexOf("top") == -1)
                     {
                        _loc26_.y = 0;
                        _loc26_.h += _loc12_;
                        _loc26_.r.tl = 0;
                        _loc26_.r.tr = 0;
                        _loc24_.tl = 0;
                        _loc24_.tr = 0;
                        _loc40_ = false;
                     }
                     if(_loc11_.indexOf("right") == -1)
                     {
                        _loc26_.w += _loc12_;
                        _loc26_.r.tr = 0;
                        _loc26_.r.br = 0;
                        _loc24_.tr = 0;
                        _loc24_.br = 0;
                        _loc40_ = false;
                     }
                     if(_loc11_.indexOf("bottom") == -1)
                     {
                        _loc26_.h += _loc12_;
                        _loc26_.r.bl = 0;
                        _loc26_.r.br = 0;
                        _loc24_.bl = 0;
                        _loc24_.br = 0;
                        _loc40_ = false;
                     }
                  }
                  if(_loc23_ == 0 && _loc40_)
                  {
                     drawDropShadow(0,0,param1,param2,0,0,0,0);
                     _loc31_.beginFill(_loc10_);
                     _loc31_.drawRect(0,0,param1,param2);
                     _loc31_.drawRect(_loc12_,_loc12_,param1 - 2 * _loc12_,param2 - 2 * _loc12_);
                     _loc31_.endFill();
                  }
                  else if(_loc24_)
                  {
                     drawDropShadow(0,0,param1,param2,_loc24_.tl,_loc24_.tr,_loc24_.br,_loc24_.bl);
                     drawRoundRect(0,0,param1,param2,_loc24_,_loc10_,1,null,null,null,_loc26_);
                     _loc24_.tl = Math.max(_loc23_ - _loc12_,0);
                     _loc24_.tr = Math.max(_loc23_ - _loc12_,0);
                     _loc24_.bl = _loc25_ ? Math.max(_loc23_ - _loc12_,0) : 0;
                     _loc24_.br = _loc25_ ? Math.max(_loc23_ - _loc12_,0) : 0;
                  }
                  else
                  {
                     drawDropShadow(0,0,param1,param2,_loc23_,_loc23_,_loc23_,_loc23_);
                     drawRoundRect(0,0,param1,param2,_loc23_,_loc10_,1,null,null,null,_loc26_);
                     _loc23_ = Math.max(getStyle("cornerRadius") - _loc12_,0);
                  }
            }
         }
         if(_loc4_ !== null && _loc4_ !== "" || getStyle("mouseShield") || getStyle("mouseShieldChildren"))
         {
            _loc42_ = Number(_loc4_);
            _loc43_ = 1;
            _loc44_ = borderMetrics;
            if(isNaN(_loc42_) || _loc4_ === "" || _loc4_ === null)
            {
               _loc43_ = 0;
               _loc42_ = 16777215;
            }
            else
            {
               _loc43_ = getStyle(_loc7_);
            }
            if(_loc23_ != 0 || Boolean(_loc8_))
            {
               _loc45_ = _loc44_.bottom;
               if(_loc24_)
               {
                  _loc46_ = _loc25_ ? _loc23_ : 0;
                  _loc24_ = {
                     "tl":_loc23_,
                     "tr":_loc23_,
                     "bl":_loc46_,
                     "br":_loc46_
                  };
                  drawRoundRect(_loc44_.left,_loc44_.top,width - (_loc44_.left + _loc44_.right),height - (_loc44_.top + _loc45_),_loc24_,_loc42_,_loc43_,null,GradientType.LINEAR,null,_loc8_);
               }
               else
               {
                  drawRoundRect(_loc44_.left,_loc44_.top,width - (_loc44_.left + _loc44_.right),height - (_loc44_.top + _loc45_),_loc23_,_loc42_,_loc43_,null,GradientType.LINEAR,null,_loc8_);
               }
            }
            else
            {
               _loc31_.beginFill(_loc42_,_loc43_);
               _loc31_.drawRect(_loc44_.left,_loc44_.top,param1 - _loc44_.right - _loc44_.left,param2 - _loc44_.bottom - _loc44_.top);
               _loc31_.endFill();
            }
         }
      }
   }
}

